VERSION 2.00
Begin Form Form1 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Grid Routines"
   ClientHeight    =   5400
   ClientLeft      =   2355
   ClientTop       =   1275
   ClientWidth     =   4875
   Height          =   5805
   Left            =   2295
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   5400
   ScaleWidth      =   4875
   Top             =   930
   Width           =   4995
   Begin TextBox Text1 
      BackColor       =   &H00FFFF00&
      Height          =   285
      Left            =   2040
      TabIndex        =   0
      Top             =   5460
      Width           =   555
   End
   Begin CommandButton Command1 
      Caption         =   "&Quit"
      Height          =   420
      Index           =   6
      Left            =   2880
      TabIndex        =   12
      Top             =   4620
      Width           =   1020
   End
   Begin CommandButton Command1 
      Caption         =   "&Load Grid"
      Height          =   420
      Index           =   5
      Left            =   1860
      TabIndex        =   11
      Top             =   4620
      Width           =   1020
   End
   Begin CommandButton Command1 
      Caption         =   "&Save Grid"
      Height          =   420
      Index           =   4
      Left            =   780
      TabIndex        =   10
      Top             =   4620
      Width           =   1080
   End
   Begin CommandButton Command1 
      Caption         =   "&To Clipbd"
      Height          =   420
      Index           =   3
      Left            =   3360
      TabIndex        =   9
      Top             =   4200
      Width           =   1020
   End
   Begin CommandButton Command1 
      Caption         =   "&Clear Grid"
      Height          =   420
      Index           =   2
      Left            =   2340
      TabIndex        =   8
      Top             =   4200
      Width           =   1020
   End
   Begin CommandButton Command1 
      Caption         =   "&Add Row"
      Height          =   435
      Index           =   1
      Left            =   1320
      TabIndex        =   7
      Top             =   4200
      Width           =   1035
   End
   Begin CommandButton Command1 
      Caption         =   "&Del Row"
      Height          =   435
      Index           =   0
      Left            =   300
      TabIndex        =   6
      Top             =   4200
      Width           =   1035
   End
   Begin PictureBox Grid1 
      BackColor       =   &H000000FF&
      Height          =   1000
      Left            =   0
      ScaleHeight     =   975
      ScaleWidth      =   975
      TabIndex        =   1
      Top             =   0
      Width           =   1000
   End
   Begin Label Label4 
      Alignment       =   2  'Center
      BackColor       =   &H000000FF&
      Caption         =   "0"
      ForeColor       =   &H00FFFFFF&
      Height          =   225
      Left            =   2910
      TabIndex        =   5
      Top             =   3750
      Width           =   375
   End
   Begin Label Label2 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Col:"
      Height          =   225
      Left            =   2385
      TabIndex        =   3
      Top             =   3750
      Width           =   405
   End
   Begin Label Label3 
      Alignment       =   2  'Center
      BackColor       =   &H000000FF&
      Caption         =   "0"
      ForeColor       =   &H00FFFFFF&
      Height          =   210
      Left            =   1545
      TabIndex        =   4
      Top             =   3750
      Width           =   405
   End
   Begin Label Label1 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Row:"
      Height          =   225
      Left            =   960
      TabIndex        =   2
      Top             =   3750
      Width           =   495
   End
   Begin Label Label5 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Use Ctrl-Up, Ctrl-Down, Ctrl-Right, Ctrl-Left to Scroll."
      Height          =   495
      Left            =   1200
      TabIndex        =   13
      Top             =   420
      Width           =   2655
   End
End
DefInt A-Z

'Grid Scrolling And Control Program
'Copyright 1991 Nelson Ford, Public (software) Library
'For documentation and copyright license,
'  see the file Grid.Bas

'The code in this module which allows overlapping controls
'was developed by Keith Funk

Declare Function ControlhWnd Lib "ctlhwnd.dll" (Ctl As Control) As Integer
Declare Function GetFocus Lib "User" ()
Declare Sub SetWindowPos Lib "User" (ByVal hWnd As Integer, ByVal hWndInsertAfter As Integer, ByVal x As Integer, ByVal Y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer)
Declare Function GetWindow Lib "User" (ByVal hWnd As Integer, ByVal wCmd As Integer) As Integer
Declare Function GetNextWindow Lib "User" (ByVal hWnd As Integer, ByVal wFlag As Integer) As Integer
Declare Function GetWindowLong Lib "User" (ByVal hWnd As Integer, ByVal nIndex As Integer) As Long
Declare Function SetWindowLong Lib "User" (ByVal hWnd As Integer, ByVal nIndex As Integer, ByVal dwNewLong As Long) As Long

Const WS_CLIPSIBLINGS = &H4000000
Const SWP_NOSIZE = &H1
Const SWP_NOMOVE = &H2
Const GW_HWNDNEXT = 2
Const GW_CHILD = 5
Const GWL_STYLE = (-16)

Sub Command1_Click (Index As Integer)
  Select Case Index
    Case 0
      DelRow Grid1
    Case 1
      InsertRow Grid1
    Case 2
      ClearGrid Grid1
    Case 3
      Grid2Clip Grid1
    Case 4
      SaveGrid Grid1, "GridTest", Cancel
    Case 5
      LoadGrid Grid1, "GridTest"
    Case 6
      End
  End Select
  'keep the Grid highlight under the Text box:
  Grid1.SelStartCol = Grid1.Col
  Grid1.SelEndCol = Grid1.Col
  Grid1.SelStartRow = Grid1.row
  Grid1.SelEndRow = Grid1.row
  Text1.SetFocus
End Sub

Sub Form_Load ()
  Form1.Show
  Call SetClipSiblingBit(Form1.hWnd)
  'get hWnd for the controls:
     Grid1.SetFocus
     G = GetFocus()
     Text1.SetFocus
     t = GetFocus()
  Call SetWindowPos(G, t, 0, 0, 0, 0, (SWP_NOSIZE Or SWP_NOMOVE))
  Grid1.row = 0
  Grid1.Col = 0
  Text1.Top = Grid1.Top
  Text1.Left = Grid1.Left
  Text1.Width = Grid1.ColWidth + 20
  Text1.Visible = -1
End Sub

Sub SetClipSiblingBit (ByVal hWndParent As Integer)
  Dim hWndChild As Integer
  Dim Style As Long
  hWndChild = GetWindow(hWndParent, GW_CHILD)
  Do
    Style = GetWindowLong(hWndChild, GWL_STYLE)
    Style = Style Or WS_CLIPSIBLINGS
    Style = SetWindowLong(hWndChild, GWL_STYLE, Style)
    If GetWindow(hWndChild, GW_CHILD) <> 0 Then
      Call SetClipSiblingBit(hWndChild)
    End If
    hWndChild = GetNextWindow(hWndChild, GW_HWNDNEXT)
  Loop Until hWndChild = 0
End Sub

Sub Text1_KeyDown (KeyCode As Integer, Shift As Integer)
  'If keycode <> 17 Then Debug.Print keycode
  If Shift = 2 And (KeyCode > 36 And KeyCode < 41) Then
    MoveCell Grid1, Text1, KeyCode
    Label3.Caption = LTrim$(Str$(Grid1.row))
    Label4.Caption = LTrim$(Str$(Grid1.Col))
  End If
End Sub

